> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Export a workbook

POST https://api.sigmacomputing.com/v2/workbooks/{workbookId}/send
Content-Type: application/json

Export a workbook to one or more destinations, such as an email address, a Slack channel, or cloud storage.

  ### Usage notes

  - Retrieve the **workbookId** by calling the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint.
  - This endpoint is rate limited to 100 requests per minute.
      

Reference: https://help.sigmacomputing.com/reference/send-workbook

## Authentication

- OAuth2 — send the obtained token as `Authorization: Bearer <token>`

## Servers

- `https://api.sigmacomputing.com` (Server for GCP (US) hosted organizations, default)
- `https://api.sa.gcp.sigmacomputing.com` (Server for GCP (KSA) hosted organizations)
- `https://aws-api.sigmacomputing.com` (Server for AWS US (West) hosted organizations)
- `https://api.us-a.aws.sigmacomputing.com` (Server for AWS US (East) hosted organizations)
- `https://api.ca.aws.sigmacomputing.com` (Server for AWS Canada hosted organizations)
- `https://api.eu.aws.sigmacomputing.com` (Server for AWS Europe hosted organizations)
- `https://api.au.aws.sigmacomputing.com` (Server for AWS Australia and APAC hosted organizations)
- `https://api.uk.aws.sigmacomputing.com` (Server for AWS UK hosted organizations)
- `https://api.us.azure.sigmacomputing.com` (Server for Azure US hosted organizations)
- `https://api.eu.azure.sigmacomputing.com` (Server for Azure Europe hosted organizations)
- `https://api.ca.azure.sigmacomputing.com` (Server for Azure Canada hosted organizations)
- `https://api.uk.azure.sigmacomputing.com` (Server for Azure United Kingdom hosted organizations)
- `https://api.au.azure.sigmacomputing.com` (Server for Azure Australia hosted organizations)

## Request

### Path parameters

- `workbookId` (string, required) — Unique identifier of the workbook.

### Body (application/json)

This endpoint expects an object.

- `targets` (list of V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItems, required)
- `config` (V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaConfig, required)
- `attachments` (list of V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItems, required)
- `parameters` (map from string to string, optional)
- `timeout` (double, optional)
- `conditions` (list of V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaConditionsItems, optional)
- `sendAsUser` (string, optional)

## Response

### 200

The response body.

## Types

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItems

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaConfig

- `title` (string, required)
- `messageBody` (string, required)
- `includeLink` (boolean, optional)
- `runAsRecipient` (boolean, optional)
- `rowLimit` (double, optional)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItems

- `formatOptions` (V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItemsFormatOptions, required)
- `source` (V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItemsSource, required)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaConditionsItems

Send based on conditions

### User

- `type` (enum, required)
  - Allowed values: `member`
- `userId` (string, required)

### Team

- `type` (enum, required)
  - Allowed values: `team`
- `teamId` (string, required)

### Email

- `type` (enum, required)
  - Allowed values: `email`
- `email` (string, required)

### Slack channel

- `type` (enum, required)
  - Allowed values: `slackChannel`
- `slackConversationId` (string, required)

### Google Sheets

- `type` (enum, required)
  - Allowed values: `gsheet`
- `googleSpreadsheetUrl` (string, required)

### Google Drive

- `type` (enum, required)
  - Allowed values: `gdrive`
- `googleDriveFolderUrl` (string, required)

### Cloud Storage

- `type` (enum, required)
  - Allowed values: `cloud-export`
- `cloudExport` (V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf6CloudExport, required)

### Webhook

- `type` (enum, required)
  - Allowed values: `webhook`
- `webhookUrl` (string, required)

### Cloud Storage for a Workbook

- `type` (enum, required)
  - Allowed values: `workbook-cloud-export`
- `workbookCloudExport` (V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf8WorkbookCloudExport, required)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItemsFormatOptions

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItemsSource

### Is Empty

- `type` (enum, required)
  - Allowed values: `isEmpty`
- `elementId` (string, required)

### Is Not Empty

- `type` (enum, required)
  - Allowed values: `isNotEmpty`
- `elementId` (string, required)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaConditionsItems2

- `type` (enum, required)
  - Allowed values: `sheetColumn`
- `elementId` (string, required)
- `columnId` (string, required)
- `op` (enum, required) — Operator
  - Allowed values: `Equals`, `GreaterThan`, `GreaterThanEq`, `LessThan`, `LessThanEq`, `NotEquals`, `IsNull`, `IsNotNull`, `Contains`, `StartsWith`, `EndsWith`
- `mode` (enum, required) — Check condition
  - Allowed values: `any`, `all`
- `value` (DataTypes, optional, nullable) — Data value

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf6CloudExport

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf8WorkbookCloudExport

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItemsFormatOptions0

- `type` (enum, required)
  - Allowed values: `CSV`

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItemsFormatOptions1

- `type` (enum, required)
  - Allowed values: `JSON`

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItemsFormatOptions2

- `type` (enum, required)
  - Allowed values: `JSONL`

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItemsFormatOptions3

- `type` (enum, required)
  - Allowed values: `EXCEL`

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItemsFormatOptions4

- `type` (enum, required)
  - Allowed values: `PDF`
- `layout` (enum, optional)
  - Allowed values: `portrait`, `landscape`
- `scaleFactor` (double, optional, nullable)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItemsFormatOptions5

- `type` (enum, required)
  - Allowed values: `PNG`
- `pixelWidth` (double, optional, nullable)
- `pixelHeight` (double, optional, nullable)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaAttachmentsItemsFormatOptions6

- `type` (enum, required)
  - Allowed values: `NONE`

### One element

Export one element

- `type` (enum, required)
  - Allowed values: `element`
- `elementId` (string, required)

### One page

Export one page

- `type` (enum, required)
  - Allowed values: `page`
- `pageId` (string, required)

### Multiple elements

Export multiple elements

- `type` (enum, required)
  - Allowed values: `element`
- `nodeIds` (list of string, required)

### Multiple pages

Export multiple pages

- `type` (enum, required)
  - Allowed values: `page`
- `nodeIds` (list of string, required)

### Entire workbook

Export all pages and elements in a workbook

- `type` (enum, required)
  - Allowed values: `all`

### DataTypes

Set a constant value for condition

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf6CloudExport0

- `bq` (V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf6CloudExportOneOf0Bq, required)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf6CloudExport1

- `sf` (V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf6CloudExportOneOf1Sf, required)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf6CloudExport2

- `rs` (V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf6CloudExportOneOf2Rs, required)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf8WorkbookCloudExport0

- `connectionType` (enum, required)
  - Allowed values: `snowflake`, `redshift`
- `authorization` (string, required)
- `uri` (string, required)
- `exportFormat` (enum, required)
  - Allowed values: `csv`, `csv.gzip`
- `timestampedUri` (string, required, nullable)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf8WorkbookCloudExport1

- `connectionType` (enum, required)
  - Allowed values: `bigQuery`
- `uri` (string, required)
- `exportFormat` (enum, required)
  - Allowed values: `csv`, `csv.gzip`
- `timestampedUri` (string, required, nullable)

### Null

- `type` (enum, required)
  - Allowed values: `null`

### Boolean

- `type` (enum, required)
  - Allowed values: `bool`
- `val` (boolean, required) — Set data value

### Number

- `type` (enum, required)
  - Allowed values: `number`
- `val` (double, required) — Set data value

### String

- `type` (enum, required)
  - Allowed values: `string`
- `val` (string, required) — Set data value

### Integer

- `type` (enum, required)
  - Allowed values: `integer`
- `val` (string, required) — Set data value

### DateTime

- `type` (enum, required)
  - Allowed values: `datetime`
- `val` (string, required) — Set data value

### Error

- `type` (enum, required)
  - Allowed values: `error`
- `val` (string, required) — Set data value

### Record

- `type` (enum, required)
  - Allowed values: `record`
- `val` (map from string to DataTypes, required) — Set data value

### Variant

- `type` (enum, required)
  - Allowed values: `variant`
- `val` (string, required)

### Array

- `type` (enum, required)
  - Allowed values: `array`
- `val` (DataTypesOneOf9Val, required)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf6CloudExportOneOf0Bq

- `bqDestination` (string, required)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf6CloudExportOneOf1Sf

- `sfDestination` (string, required)
- `authorization` (string, required)

### V2WorkbooksWorkbookIdSendPostRequestBodyContentApplicationJsonSchemaTargetsItemsOneOf6CloudExportOneOf2Rs

- `rsDestination` (string, required)
- `authorization` (string, required)

### DataTypesOneOf9Val

### DataTypesOneOf9Val0

- `type` (enum, required)
  - Allowed values: `boolArr`
- `data` (list of boolean, required)

### DataTypesOneOf9Val1

- `type` (enum, required)
  - Allowed values: `numberArr`
- `data` (list of double, required)

### DataTypesOneOf9Val2

- `type` (enum, required)
  - Allowed values: `bigintArr`
- `data` (list of string, required)

### DataTypesOneOf9Val3

- `type` (enum, required)
  - Allowed values: `stringArr`
- `data` (list of string, required)

### DataTypesOneOf9Val4

- `type` (enum, required)
  - Allowed values: `datetimeArr`
- `data` (list of double, required)

### DataTypesOneOf9Val5

- `type` (enum, required)
  - Allowed values: `bytesArr`
- `data` (list of string, required)

### DataTypesOneOf9Val6

- `type` (enum, required)
  - Allowed values: `variantArr`
- `data` (list of string, required)

## Examples

**Request**

```json
{
  "targets": [
    {
      "email": "test@example.com",
      "type": "email"
    }
  ],
  "config": {
    "title": "My report",
    "messageBody": "My report body",
    "includeLink": true,
    "runAsRecipient": true
  },
  "attachments": [
    {
      "formatOptions": {
        "type": "PDF"
      },
      "source": {
        "type": "all"
      }
    }
  ]
}
```

**Response**

```json
{}
```

**SDK Code**

```python Example request
import requests

url = "https://api.sigmacomputing.com/v2/workbooks/workbookId/send"

payload = {
    "targets": [
        {
            "email": "test@example.com",
            "type": "email"
        }
    ],
    "config": {
        "title": "My report",
        "messageBody": "My report body",
        "includeLink": True,
        "runAsRecipient": True
    },
    "attachments": [
        {
            "formatOptions": { "type": "PDF" },
            "source": { "type": "all" }
        }
    ]
}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Example request
const url = 'https://api.sigmacomputing.com/v2/workbooks/workbookId/send';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"targets":[{"email":"test@example.com","type":"email"}],"config":{"title":"My report","messageBody":"My report body","includeLink":true,"runAsRecipient":true},"attachments":[{"formatOptions":{"type":"PDF"},"source":{"type":"all"}}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example request
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/workbooks/workbookId/send"

	payload := strings.NewReader("{\n  \"targets\": [\n    {\n      \"email\": \"test@example.com\",\n      \"type\": \"email\"\n    }\n  ],\n  \"config\": {\n    \"title\": \"My report\",\n    \"messageBody\": \"My report body\",\n    \"includeLink\": true,\n    \"runAsRecipient\": true\n  },\n  \"attachments\": [\n    {\n      \"formatOptions\": {\n        \"type\": \"PDF\"\n      },\n      \"source\": {\n        \"type\": \"all\"\n      }\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example request
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/workbooks/workbookId/send")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"targets\": [\n    {\n      \"email\": \"test@example.com\",\n      \"type\": \"email\"\n    }\n  ],\n  \"config\": {\n    \"title\": \"My report\",\n    \"messageBody\": \"My report body\",\n    \"includeLink\": true,\n    \"runAsRecipient\": true\n  },\n  \"attachments\": [\n    {\n      \"formatOptions\": {\n        \"type\": \"PDF\"\n      },\n      \"source\": {\n        \"type\": \"all\"\n      }\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Example request
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/workbooks/workbookId/send")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"targets\": [\n    {\n      \"email\": \"test@example.com\",\n      \"type\": \"email\"\n    }\n  ],\n  \"config\": {\n    \"title\": \"My report\",\n    \"messageBody\": \"My report body\",\n    \"includeLink\": true,\n    \"runAsRecipient\": true\n  },\n  \"attachments\": [\n    {\n      \"formatOptions\": {\n        \"type\": \"PDF\"\n      },\n      \"source\": {\n        \"type\": \"all\"\n      }\n    }\n  ]\n}")
  .asString();
```

```php Example request
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/workbooks/workbookId/send', [
  'body' => '{
  "targets": [
    {
      "email": "test@example.com",
      "type": "email"
    }
  ],
  "config": {
    "title": "My report",
    "messageBody": "My report body",
    "includeLink": true,
    "runAsRecipient": true
  },
  "attachments": [
    {
      "formatOptions": {
        "type": "PDF"
      },
      "source": {
        "type": "all"
      }
    }
  ]
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Example request
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/workbooks/workbookId/send");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"targets\": [\n    {\n      \"email\": \"test@example.com\",\n      \"type\": \"email\"\n    }\n  ],\n  \"config\": {\n    \"title\": \"My report\",\n    \"messageBody\": \"My report body\",\n    \"includeLink\": true,\n    \"runAsRecipient\": true\n  },\n  \"attachments\": [\n    {\n      \"formatOptions\": {\n        \"type\": \"PDF\"\n      },\n      \"source\": {\n        \"type\": \"all\"\n      }\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example request
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [
  "targets": [
    [
      "email": "test@example.com",
      "type": "email"
    ]
  ],
  "config": [
    "title": "My report",
    "messageBody": "My report body",
    "includeLink": true,
    "runAsRecipient": true
  ],
  "attachments": [
    [
      "formatOptions": ["type": "PDF"],
      "source": ["type": "all"]
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/workbooks/workbookId/send")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```